<?php
class ControllerExtensionModuleGlslabel extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/glslabel');

		$this->document->setTitle($this->language->get('heading_title'));

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->load->model('setting/setting');

			$this->model_setting_setting->editSetting('gls_label', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->cache->delete('gls_label');
			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_module'] = $this->language->get('text_module');
		$data['text_edit'] = $this->language->get('text_edit');

		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['enable'] = $this->language->get('enable');
		$data['disable'] = $this->language->get('disable');

		$data['text_main_data_title'] = $this->language->get('text_main_data_title');
		$data['label_username'] = $this->language->get('label_username');
		$data['label_password'] = $this->language->get('label_password');
		$data['label_api_key'] = $this->language->get('label_api_key');
		$data['label_after_status'] = $this->language->get('label_after_status');
		$data['label_paper_size'] = $this->language->get('label_paper_size');
		$data['prepinted'] = $this->language->get('prepinted');
		$data['on_a4_paper'] = $this->language->get('on_a4_paper');
		$data['thermal_paper'] = $this->language->get('thermal_paper');

		$data['text_shop_header_title'] = $this->language->get('text_shop_header_title');
		$data['label_shop_name'] = $this->language->get('label_shop_name');
		$data['label_shop_address'] = $this->language->get('label_shop_address');
		$data['label_shop_city'] = $this->language->get('label_shop_city');
		$data['label_shop_zip'] = $this->language->get('label_shop_zip');
		$data['label_shop_country'] = $this->language->get('label_shop_country');
		$data['hungary'] = $this->language->get('hungary');
		$data['slovakia'] = $this->language->get('slovakia');
		$data['czech'] = $this->language->get('czech');
		$data['romania'] = $this->language->get('romania');
		$data['slovenia'] = $this->language->get('slovenia');
		$data['croatia'] = $this->language->get('croatia');
		$data['label_shop_email'] = $this->language->get('shop_email');

		$data['text_sender_title'] = $this->language->get('text_sender_title');
		$data['label_sender_name'] = $this->language->get('label_sender_name');
		$data['label_sender_phone'] = $this->language->get('label_sender_phone');
		
		$data['license_key'] = $this->language->get('license_key');
		$data['license_title'] = $this->language->get('license_title');


		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['form_action'] = $data['action'] = $this->url->link('extension/module/glslabel', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);
		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->request->post['gls_label_license_key'])) {
			$data['gls_label_license_key'] = $this->request->post['gls_label_license_key'];
		} else {
			$data['gls_label_license_key'] = $this->config->get('gls_label_license_key');
		}
		
		if (isset($this->request->post['gls_label_username'])) {
			$data['gls_label_username'] = $this->request->post['gls_label_username'];
		} else {
			$data['gls_label_username'] = $this->config->get('gls_label_username');
		}
		
		if (isset($this->request->post['gls_label_password'])) {
			$data['gls_label_password'] = $this->request->post['gls_label_password'];
		} else {
			$data['gls_label_password'] = $this->config->get('gls_label_password');
		}
		
		if (isset($this->request->post['gls_label_shop_name'])) {
			$data['gls_label_shop_name'] = $this->request->post['gls_label_shop_name'];
		} else {
			$data['gls_label_shop_name'] = $this->config->get('gls_label_shop_name');
			if ($data['gls_label_shop_name']=='' && $this->config->get('config_name')!='') {
				$data['gls_label_shop_name'] = $this->config->get('config_name');
			}
		}
		
		if (isset($this->request->post['gls_label_shop_address'])) {
			$data['gls_label_shop_address'] = $this->request->post['gls_label_shop_address'];
		} else {
			$data['gls_label_shop_address'] = $this->config->get('gls_label_shop_address');
		}
		
		if (isset($this->request->post['gls_label_shop_city'])) {
			$data['gls_label_shop_city'] = $this->request->post['gls_label_shop_city'];
		} else {
			$data['gls_label_shop_city'] = $this->config->get('gls_label_shop_city');
		}
		
		if (isset($this->request->post['gls_label_shop_zip'])) {
			$data['gls_label_shop_zip'] = $this->request->post['gls_label_shop_zip'];
		} else {
			$data['gls_label_shop_zip'] = $this->config->get('gls_label_shop_zip');
		}
		
		if (isset($this->request->post['gls_label_shop_country'])) {
			$data['gls_label_shop_country'] = $this->request->post['gls_label_shop_country'];
		} else {
			$data['gls_label_shop_country'] = $this->config->get('gls_label_shop_country');
		}
		
		if (isset($this->request->post['gls_label_shop_email'])) {
			$data['gls_label_shop_email'] = $this->request->post['gls_label_shop_email'];
		} else {
			$data['gls_label_shop_email'] = $this->config->get('gls_label_shop_email');
			if ($data['gls_label_shop_email']=='' && $this->config->get('config_email')!='') {
				$data['gls_label_shop_email'] = $this->config->get('config_email');
			}
		}
		
		if (isset($this->request->post['gls_label_sender_name'])) {
			$data['gls_label_sender_name'] = $this->request->post['gls_label_sender_name'];
		} else {
			$data['gls_label_sender_name'] = $this->config->get('gls_label_sender_name');
			if ($data['gls_label_sender_name']=='' && $this->config->get('config_owner')!='') {
				$data['gls_label_sender_name'] = $this->config->get('config_owner');
			}
		}
		
		if (isset($this->request->post['gls_label_sender_phone'])) {
			$data['gls_label_sender_phone'] = $this->request->post['gls_label_sender_phone'];
		} else {
			$data['gls_label_sender_phone'] = $this->config->get('gls_label_sender_phone');
			if ($data['gls_label_sender_phone']=='' && $this->config->get('config_telephone')!='') {
				$data['gls_label_sender_phone'] = $this->config->get('config_telephone');
			}
		}
		
		if (isset($this->request->post['gls_label_frontend_tracking'])) {
			$data['gls_label_frontend_tracking'] = $this->request->post['gls_label_frontend_tracking'];
		} else {
			$data['gls_label_frontend_tracking'] = $this->config->get('gls_label_frontend_tracking');
		}
		
		if (isset($this->request->post['gls_label_paper_size'])) {
			$data['gls_label_paper_size'] = $this->request->post['gls_label_paper_size'];
		} else {
			$data['gls_label_paper_size'] = $this->config->get('gls_label_paper_size');
		} 
		if (isset($this->request->post['gls_label_order_status_id'])) {
			$data['gls_label_order_status_id'] = $this->request->post['gls_label_order_status_id'];
		} else {
			$status = 1;
			if (!is_null($this->config->get('gls_label_order_status_id'))) {
				$status = $this->config->get('gls_label_order_status_id');
			}
			$data['gls_label_order_status_id'] = $status;
		}
		
		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();	

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/glslabel', 'token=' . $this->session->data['token'], true)
		);
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/glslabel.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/glslabel')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
	
	public function install() {
		$this->db->query("ALTER TABLE `" . DB_PREFIX . "order_history` ADD COLUMN `gls_trackcode` varchar(32) charset utf8 collate utf8_unicode_ci default'' NOT NULL after `comment`");
	}

	public function uninstall() {
		$this->db->query("ALTER TABLE " . DB_PREFIX . "order_history DROP `gls_trackcode`");
	}	
}